
datablock ParticleData(M12_LRVFlashParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 50;
  lifetimeVarianceMS = 0;
  textureName = "./M45Flash";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "1 1 1 1";
  colors[1] = "1 1 1 1";
  colors[2] = "1 1 1 0";
  sizes[0] = 0.2;
  sizes[1] = 2;
  sizes[2] = 1;
  times[9] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(M12_LRVFlashEmitter)
{
  uiName = "";
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 250;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 10;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "M12_LRVFlashParticle";
};

datablock ParticleData(M12_LRVbulletTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.9 0.0 0.8";
	colors[1]     = "0.9 0.9 0.0 0.6";
	colors[2]     = "0.9 0.9 0.0 0.0";
	sizes[0]      = 0.06;
	sizes[1]      = 0.06;
	sizes[2]	  = 0.01;
	times[0]      = 0.0;
	times[1]	  = 0.9;
	times[2]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(M12_LRVbulletTrailEmitter)
{
   ejectionPeriodMS = 8;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "M12_LRVbulletTrailParticle";
};

datablock ProjectileData(M12_LRVProjectile)
{
   projectileShapeName = "./30mmAA.dts";
   directDamage        = 84;
   directDamageType    = $DamageType::Gun;
   radiusDamageType    = $DamageType::Gun;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 15;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 20;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 300;
   explosion           = GunExplosion;
   //particleEmitter     = M12_LRVbulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

datablock ShapeBaseImageData(M12_LRVSmokeImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = 1;

	stateName[0]                  = "Ready";
	stateTransitionOnTimeout[0]   = "FireA";
	stateTimeoutValue[0]          = 0.01;

	stateName[1]                  = "FireA";
	stateTransitionOnTimeout[1]   = "Done";
	stateWaitForTimeout[1]        = True;
	stateTimeoutValue[1]          = 0.05;
	stateEmitter[1]               = M12_LRVFlashEmitter;
	stateEmitterTime[1]           = 0.05;


	stateName[2]                  = "Done";
	stateScript[2]                = "onDone";
};
function M12_LRVSmokeImage::onDone(%this,%obj,%slot)
{
	%obj.unMountImage(%slot);
}



datablock AudioDescription(M12_LRVLooping3d)
{
   volume   = 8.0;
   isLooping= true;

   is3D     = true;
   ReferenceDistance= 5.5;
   MaxDistance= 80.0;
   type     = $SimAudioType;
};
datablock AudioProfile(M12_LRVSound)
{
   filename    = "./Engine.wav";
   description = M12_LRVLooping3d;
   preload = true;
};

datablock AudioProfile(LAAGFireSound)
{
  filename = "./30mmFire.wav";
  description = AudioClosest3d;
  preload = true;
};



datablock TSShapeConstructor(M12_LRV_LAAGDts)
{
	baseShape  = "./M12_LRV_LAAG.dts";
	sequence0  = "./Turret/M12_LRV_root.dsq root";

	sequence1  = "./Turret/M12_LRV_root.dsq run";
	sequence2  = "./Turret/M12_LRV_root.dsq walk";
	sequence3  = "./Turret/M12_LRV_root.dsq back";
	sequence4  = "./Turret/M12_LRV_root.dsq side";

	sequence5  = "./Turret/M12_LRV_root.dsq crouch";
	sequence6  = "./Turret/M12_LRV_root.dsq crouchRun";
	sequence7  = "./Turret/M12_LRV_root.dsq crouchBack";
	sequence8  = "./Turret/M12_LRV_root.dsq crouchSide";

	sequence9  = "./Turret/M12_LRV_look.dsq look";
	sequence10 = "./Turret/M12_LRV_root.dsq headside";
	sequence11 = "./Turret/M12_LRV_root.dsq headUp";

	sequence12 = "./Turret/M12_LRV_root.dsq jump";
	sequence13 = "./Turret/M12_LRV_root.dsq standjump";
	sequence14 = "./Turret/M12_LRV_root.dsq fall";
	sequence15 = "./Turret/M12_LRV_root.dsq land";

	sequence16 = "./Turret/M12_LRV_root.dsq armAttack";
	sequence17 = "./Turret/M12_LRV_root.dsq armReadyLeft";
	sequence18 = "./Turret/M12_LRV_root.dsq armReadyRight";
	sequence19 = "./Turret/M12_LRV_root.dsq armReadyBoth";
	sequence20 = "./Turret/M12_LRV_root.dsq spearready";  
	sequence21 = "./Turret/M12_LRV_root.dsq spearThrow";

	sequence22 = "./Turret/M12_LRV_root.dsq talk";  

	sequence23 = "./Turret/M12_LRV_root.dsq death1"; 
	
	sequence24 = "./Turret/M12_LRV_root.dsq shiftUp";
	sequence25 = "./Turret/M12_LRV_root.dsq shiftDown";
	sequence26 = "./Turret/M12_LRV_root.dsq shiftAway";
	sequence27 = "./Turret/M12_LRV_root.dsq shiftTo";
	sequence28 = "./Turret/M12_LRV_root.dsq shiftLeft";
	sequence29 = "./Turret/M12_LRV_root.dsq shiftRight";
	sequence30 = "./Turret/M12_LRV_root.dsq rotCW";
	sequence31 = "./Turret/M12_LRV_root.dsq rotCCW";

	sequence32 = "./Turret/M12_LRV_root.dsq undo";
	sequence33 = "./Turret/M12_LRV_root.dsq plant";

	sequence34 = "./Turret/M12_LRV_root.dsq sit";

	sequence35 = "./Turret/M12_LRV_root.dsq wrench";
	sequence36 = "./Turret/M12_LRV_fire.dsq fire";
};    

datablock TSShapeConstructor(M12_LRVDts)
{
	baseShape  = "./M12_LRV.dts";
	sequence0  = "./M12_LRV_root.dsq root";

	sequence1  = "./M12_LRV_root.dsq run";
	sequence2  = "./M12_LRV_root.dsq walk";
	sequence3  = "./M12_LRV_root.dsq back";
	sequence4  = "./M12_LRV_root.dsq side";

	sequence5  = "./M12_LRV_root.dsq crouch";
	sequence6  = "./M12_LRV_root.dsq crouchRun";
	sequence7  = "./M12_LRV_root.dsq crouchBack";
	sequence8  = "./M12_LRV_root.dsq crouchSide";

	sequence9  = "./M12_LRV_look.dsq look";
	sequence10 = "./M12_LRV_root.dsq headside";
	sequence11 = "./M12_LRV_root.dsq headUp";

	sequence12 = "./M12_LRV_root.dsq jump";
	sequence13 = "./M12_LRV_root.dsq standjump";
	sequence14 = "./M12_LRV_root.dsq fall";
	sequence15 = "./M12_LRV_root.dsq land";

	sequence16 = "./M12_LRV_root.dsq armAttack";
	sequence17 = "./M12_LRV_root.dsq armReadyLeft";
	sequence18 = "./M12_LRV_root.dsq armReadyRight";
	sequence19 = "./M12_LRV_root.dsq armReadyBoth";
	sequence20 = "./M12_LRV_root.dsq spearready";  
	sequence21 = "./M12_LRV_root.dsq spearThrow";

	sequence22 = "./M12_LRV_root.dsq talk";  

	sequence23 = "./M12_LRV_root.dsq death1"; 
	
	sequence24 = "./M12_LRV_root.dsq shiftUp";
	sequence25 = "./M12_LRV_root.dsq shiftDown";
	sequence26 = "./M12_LRV_root.dsq shiftAway";
	sequence27 = "./M12_LRV_root.dsq shiftTo";
	sequence28 = "./M12_LRV_root.dsq shiftLeft";
	sequence29 = "./M12_LRV_root.dsq shiftRight";
	sequence30 = "./M12_LRV_root.dsq rotCW";
	sequence31 = "./M12_LRV_root.dsq rotCCW";

	sequence32 = "./M12_LRV_root.dsq undo";
	sequence33 = "./M12_LRV_root.dsq plant";

	sequence34 = "./M12_LRV_root.dsq sit";

	sequence35 = "./M12_LRV_root.dsq wrench";
	sequence36 = "./M12_LRV_spring0.dsq spring0";
	sequence37 = "./M12_LRV_spring1.dsq spring1";
	sequence38 = "./M12_LRV_spring2.dsq spring2";
	sequence39 = "./M12_LRV_spring3.dsq spring3";
};

datablock PlayerData(M12_LRV_LAAGPlayer)
{
   Hold = 1;

   renderFirstPerson = true;
   emap = false;
   
   className = Armor;
   shapeFile = "./M12_LRV_LAAG.dts";
   cameraMaxDist = 15;
   cameraTilt = 0.261;
   cameraVerticalOffset = 5.3;
   computeCRC = false;
  
   canObserve = true;
   cmdCategory = "Clients";

   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   //debrisShapeName = "~/data/player/debris_player.dts";
   //debris = horseDebris;

   aiAvoidThis = true;

   minLookAngle = -3.5708;
   maxLookAngle = 0.5;
   maxFreelookAngle = 3.0;

   mass = 200;
   drag = 10;
   maxdrag = 0.52;
   density = 0.7;
   maxDamage = 250;
   maxEnergy =  10;
   repairRate = 0.33;
   energyPerDamagePoint = 75.0;

   rechargeRate = 0.4;

   runForce = 0 * 0;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 0;
   maxBackwardSpeed = 0;
   maxSideSpeed = 0;

   maxForwardCrouchSpeed = 0;
   maxBackwardCrouchSpeed = 0;
   maxSideCrouchSpeed = 0;

   maxForwardProneSpeed = 0;
   maxBackwardProneSpeed = 0;
   maxSideProneSpeed = 0;

   maxForwardWalkSpeed = 0;
   maxBackwardWalkSpeed = 0;
   maxSideWalkSpeed = 0;

   maxUnderwaterForwardSpeed = 0;
   maxUnderwaterBackwardSpeed = 0;
   maxUnderwaterSideSpeed = 0;

   jumpForce = 0 * 0; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

   minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

   recoverDelay = 0;
   recoverRunForceScale = 1.2;

   minImpactSpeed = 250;
   speedDamageScale = 3.8;

   boundingBox			= vectorScale("2.5 2.5 1.7", 4); 
   crouchBoundingBox	= vectorScale("2.5 2.5 1.7", 4); 
   proneBoundingBox	= vectorScale("2.5 2.5 1.7", 4); 

   pickupRadius = 0.75;
   
   // Damage location details
   boxNormalHeadPercentage       = 0.83;
   boxNormalTorsoPercentage      = 0.49;
   boxHeadLeftPercentage         = 0;
   boxHeadRightPercentage        = 1;
   boxHeadBackPercentage         = 0;
   boxHeadFrontPercentage        = 1;

   // Foot Prints
   //decalData   = HorseFootprint;
   //decalOffset = 0.25;
	
	
   jetEmitter = playerJetEmitter;
   jetGroundEmitter = playerJetGroundEmitter;
   jetGroundDistance = 4;
  
   //footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;

   //dustEmitter = LiftoffDustEmitter;

   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.1;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 5.0;

   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 85;
   jumpSurfaceAngle = 86;

   minJumpSpeed = 20;
   maxJumpSpeed = 30;

   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;
   
   footstepSplashHeight = 0.35;

   //NOTE:  some sounds commented out until wav's are available


   // Footstep Sounds
   //FootSoftSound        = HorseFootFallSound;
   //FootHardSound        = HorseFootFallSound;
   //FootMetalSound       = HorseFootFallSound;
   //FootSnowSound        = HorseFootFallSound;
   //FootShallowSound     = HorseFootFallSound;
   //FootWadingSound      = HorseFootFallSound;
   //FootUnderwaterSound  = HorseFootFallSound;
   //FootBubblesSound     = FootLightBubblesSound;
   //movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;

   //impactSoftSound      = ImpactLightSoftSound;
   //impactHardSound      = ImpactLightHardSound;
   //impactMetalSound     = ImpactLightMetalSound;
   //impactSnowSound      = ImpactLightSnowSound;
   
   //impactWaterEasy      = ImpactLightWaterEasySound;
   //impactWaterMedium    = ImpactLightWaterMediumSound;
   //impactWaterHard      = ImpactLightWaterHardSound;
   
   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;
   
   //exitingWater         = ExitingWaterLightSound;
   
   observeParameters = "0.5 4.5 4.5";

   // Inventory Items
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;
	
	rideable = true;
   lookUpLimit = 0.6;
   lookDownLimit = 0.1;

	canRide = false;
	showEnergyBar = false;
	paintable = true;

	brickImage = horseBrickImage;	//the imageData to use for brick deployment

   numMountPoints = 1;
   mountThread[0] = "root";

   //protection for passengers
   protectPassengersBurn   = true;  //protect passengers from the burning effect of explosions?
   protectPassengersRadius = false;  //protect passengers from radius damage (explosions) ?
   protectPassengersDirect = false; //protect passengers from direct damage (bullets) ?
};

datablock WheeledVehicleTire(M12_LRVTire)
{
   // Tires act as springs and generate lateral and longitudinal
   // forces to move the vehicle. These distortion/spring forces
   // are what convert wheel angular velocity into forces that
   // act on the rigid body.
   shapeFile = "./M12_LRV_Tire.dts";
	
	mass = 10;
   radius = 1;
   staticFriction = 5;
   kineticFriction = 5;
   restitution = 0.5;	

   // Spring that generates lateral tire forces
   lateralForce = 18000;
   lateralDamping = 4000;
   lateralRelaxation = 0.01;

   // Spring that generates longitudinal tire forces
   longitudinalForce = 14000;
   longitudinalDamping = 2000;
   longitudinalRelaxation = 0.01;
};

datablock WheeledVehicleSpring(M12_LRVSpring)
{
   // Wheel suspension properties
   length = 0.3;        // Suspension travel
   force = 5000;        // Spring force
   damping = 500;      // Spring damping
   antiSwayForce = 20;   // Lateral anti-sway force
};

datablock WheeledVehicleData(M12_LRVVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./M12_LRV.dts";
	emap = true;
	minMountDist = 3;
   
   numMountPoints = 3;
   mountThread[0] = "sit";
   mountThread[1] = "root";
   mountThread[2] = "armReadyBoth";



	maxDamage = 300.00;
	destroyedLevel = 300.00;
	energyPerDamagePoint = 160;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0 -0.9";
   //massBox = "2 5 1";

	maxSteeringAngle = 0.485;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 13;         // Far distance from vehicle
	cameraOffset = 7.5;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.4;
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = false;	

	defaultTire	= M12_LRVTire;
	defaultSpring	= M12_LRVSpring;

   numWheels = 4;//45/29

	// Rigid Body
	mass = 300;
	density = 5.0;
	drag = 1.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 25000; //4000;       // Engine power
	engineBrake = 5000;         // Braking when throttle is 0
	brakeTorque = 50000;        // When brakes are applied
	maxWheelSpeed = 30;        // Engine scale by current speed / max speed

	rollForce		= 50;
	yawForce		= 600;
	pitchForce		= 1000;
	rotationalDrag		= 0.2;

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

	splash = jeepSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";


//End of remove weapons script.
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = rocketLoopSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	explosion = VehicleExplosion;
	justcollided = 0;

   uiName = "M12 LRV Warthog";
	rideable = true;
   //lookUpLimit = 0.9;
   //lookDownLimit = 0.1;
   lookUpLimit  = 0.5;
   lookDownLimit = 0.5;

	paintable = true;
   
   damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

   damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

   numDmgEmitterAreas = 1;

   initialExplosionProjectile = M12_LRVExplosionProjectile;
   initialExplosionOffset = 1;         //offset only uses a z value for now

   burnTime = 4000;

   finalExplosionProjectile = VehicleFinalExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now


   minRunOverSpeed    = 4;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 25;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 1.2; //how hard a person you're running over gets pushed

   //protection for passengers
   protectPassengersBurn   = true;  //protect passengers from the burning effect of explosions?
   protectPassengersRadius = true;  //protect passengers from radius damage (explosions) ?
   protectPassengersDirect = false; //protect passengers from direct damage (bullets) ?
};

function M12_LRVVehicle::onAdd(%this,%obj)
{
   // Setup the car with some defaults tires & springs
   for(%i = 0; %i < %this.numWheels; %i++)
   {
      %obj.setWheelTire(%i, %this.defaultTire);
      %obj.setWheelSpring(%i, %this.defaultSpring);
   }

   // 4 wheel steering
   %obj.setWheelSteering(0,1);
   %obj.setWheelSteering(1,1);
   %obj.setWheelSteering(2,-1);
   %obj.setWheelSteering(3,-1);

   // 4 wheel drive
   %obj.setWheelPowered(0,true);
   %obj.setWheelPowered(1,true);
   %obj.setWheelPowered(2,true);
   %obj.setWheelPowered(3,true);

	// Engine Sound
   %obj.PlayAudio(0,M12_LRVSound);
   
   // LAAG
   %t = new AIPlayer()
   {
      dataBlock = M12_LRV_LAAGPlayer;
   };
   MissionCleanup.add(%t);
   %obj.mountObject(%t, 2);
   %obj.LAAG = %t;
   %obj.creationTime = getSimTime();
   %t.schedule(10,"rigLAAG");
   
   
   Parent::onadd(%this,%obj);
}

function Player::rigLAAG(%obj)
{
   if(%obj.dataBlock !$= M12_LRV_LAAGPlayer)
	   return;

   if(!isObject(%obj))
	   return;

   %parent = %obj.getObjectMount();
   if(!isObject(%parent))
	   return;

   %obj.spawnBrick = %parent.spawnBrick;
   %obj.brickGroup = %parent.brickGroup;
}

function M12_LRVVehicle::onRemove(%this,%obj)
{
   if(isObject(%obj.LAAG))
	   %obj.LAAG.delete();
}

function M12_LRV_LAAGPlayer::onDriverLeave(%this,%obj)
{
   %obj.setTransform("0 0 0 0 0 0 0");
}

package M12_LRVPackage
{

   function Player::burn(%obj,%time)
   {
	if(%obj.dataBlock $= M12_LRV_LAAGPlayer)
	   return;
	else
	   Parent::burn(%obj,%time);
   }

   function ShapeBase::setNodeColor(%obj,%node,%color)
   {
	parent::setnodecolor(%obj,%node,%color);
	if(isObject(%obj.LAAG))
	{
	   %obj.LAAG.setNodeColor("ALL",%color);
	}
   }

   function M12_LRVVehicle::Damage(%this,%obj,%source,%pos,%amm,%type)
   {
      if((%obj.getDamageLevel()+%amm) >= %this.maxDamage)
      {
         if(%obj.destroyed)
            return;

         %obj.setNodeColor("ALL","0 0 0 1");
         if(isObject(%obj.LAAG))
         {
            %obj.LAAG.delete();

         }
         else
         {
            %p = new Projectile()
            {
               dataBlock = vehicleExplosionProjectile;
               initialPosition = vectorAdd(%obj.getPosition(),"0 0" SPC %this.initialExplosionOffset);
               initialVelocity = "0 0 1";
               client = %obj.lastDamageClient;
               sourceClient = %obj.lastDamageClient;
            };
            MissionCleanup.add(%p);
         }
         if(%obj.destroyed)
            return;

         %obj.setDamageLevel(%this.maxDamage);
         %obj.destroyed = 1;
         %obj.schedule(%this.burnTime,"finalExplosion");
         if(isObject(%obj.spawnBrick.client.minigame))
            %respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
         %obj.spawnBrick.schedule(%respawn,"spawnVehicle");
      }
      else
         Parent::Damage(%this,%obj,%source,%pos,%amm,%type);
   }

   function Player::emote(%obj,%emote)
   {
      if(%obj.dataBlock $= M12_LRV_LAAGPlayer)
	      return;
      Parent::emote(%obj,%emote);
   }

   function M12_LRV_LAAGPlayer::onDamage(%this,%obj,%ammount)
   {
      if(%obj.dataBlock $= M12_LRV_LAAGPlayer)
         return;
	   Parent::onDamage(%this,%obj,%ammount);
   }

   function M12_LRVShellProjectile::onCollision(%this,%obj,%col,%a,%b,%c,%d,%e)
   {
      if(%col.dataBlock.className $= "Glass" && !%col.indestructable)
      {
         %col.explode();
      }
      Parent::onCollision(%this,%obj,%col,%a,%b,%c,%d,%e);
   }

   function M12_LRV_LAAGPlayer::onDisabled(%this,%obj,%state)
   {
      %p = new Projectile()
      {
         dataBlock = M12_LRV_LAAGExplosionProjectile;
         initialPosition = vectorAdd(%obj.getObjectMount().getPosition(),"0 0" SPC %obj.getObjectMount().dataBlock.initialExplosionOffset);
         initialVelocity = "0 0 1";
         client = %obj.lastDamageClient;
         sourceClient = %obj.lastDamageClient;
      };
      MissionCleanup.add(%p);
      %obj.schedule(10,"delete");
      %player = %obj.getMountedObject(0);
      if(isObject(%player))
      {
         %obj.getObjectMount().schedule(10,"mountObject",%player,2);
      }
   }

   function M12_LRV_LAAGPlayer::Damage(%this,%obj,%source,%pos,%amm,%type)
   {
      //scale the damage ammount as if this was a vehicle
      %amm *= $Damage::VehicleDamageScale[%type];

      if(%obj.getDamageLevel()+%amm > %this.maxDamage)
         %obj.setDamageLevel(%this.maxDamage);
      else
         Parent::Damage(%this,%obj,%source,%pos,%amm,%type);
   }

   function armor::onMount(%this,%obj,%col,%slot)
   {
      Parent::onMount(%this,%obj,%col,%slot);
      if(%col.dataBlock $= M12_LRVVehicle)
      {
         if(%slot $= 2)
         {
            %obj.setLookLimits(1,0);
         }
      }
      else if(%col.dataBlock $= M12_LRV_LAAGPlayer)
      {
         %client = %obj.client;
         if(isObject(%client))
            ServerCmdUnUseTool(%client);
      }

   
   }
   
  function Player::M12_LRVShoot(%obj,%triggerNum,%val)
   {
      	if(!%val) 
	{
		cancel(%obj.M12_LRV_reshoot);
		return;
	}
      
      %mount = %obj.getObjectMount();

      //hack so we can shoot if we are a tank turret
      if(%obj.getDataBlock().getID() == M12_LRV_LAAGPlayer.getID())
         %mount = %obj;

      if(isObject(%mount))
      {
         if(%mount.getDataBlock() == M12_LRV_LAAGPlayer.getId() && %triggerNum == 0 && %val)
         {
            %client = %obj.client;
            if(isObject(%client))
               ServerCmdUnUseTool(%client);



	%vector = %mount.getEyeVector(); //Get the direction they're aiming
	%velocity = VectorScale(%vector, 80); //Lengthen the vector to be the speed of the projectile we want
	%x = (getRandom() - 0.5) * 0.02; //Calculate X, Y, and Z spread randomizations
	%y = (getRandom() - 0.5) * 0.02;
	%z = (getRandom() - 0.5) * 0.02;
	%mat = MatrixCreateFromEuler(%x SPC %y SPC %z);
	%velocity = MatrixMulVector(%mat, %velocity); //Randomize the lengthened vector.
	%scaleFactor = getWord(%mount.getScale(), 2); //Get the scale so we can scale the projectile.
	%p = new projectile() //Create the projectile.
	{
		dataBlock = M12_LRVprojectile;
		initialVelocity = %velocity;
		initialPosition = %mount.getEyePoint();
		sourceObject = %obj;
		sourceSlot = %triggerNum;
		client = %obj.client;
		scale = %scaleFactor;
	};
	MissionCleanup.add(%p);
	%mount.mountImage(M12_LRVSmokeImage,1);
	%mount.playThread(0,Fire);
	serverPlay3D(LAAGFireSound,%obj.getPosition());
	%obj.lastShotTime = getSimTime();
	%ReshootDelay = 50;
	%ShootDelay = 500;
	%Hold = 1;
	if(%Hold == 1)
	{
		%obj.M12_LRV_reshoot= %obj.schedule(%ReshootDelay,M12_LRVShoot,%triggerNum,%val);
		//%obj.M12_LRV_reshoot= %obj.schedule(5,M12_LRV_Shoot,%triggerNum,%val);
	}

	%obj.client.M12_LRV_LastFireTime=$Sim::Time+%ShootDelay/1;

            return;
         }
      }
      
   }
   
   
function armor::onTrigger(%this, %obj, %triggerNum, %val)
   {
	if(%obj.getClassName()$="Player")
		{
			if(%triggerNum $= 0)
			{
				if(%val)
				{
					if($Sim::Time<%obj.client.M12_LRV_LastFireTime)
					{
					
						return;
					}
				}
				%obj.M12_LRVShoot(%triggerNum,%val);
			}
		}
	Parent::onTrigger(%this,%obj,%triggerNum,%val);
   }


};
activatepackage(M12_LRVPackage);


datablock DebrisData(LAAGDebris)
{
   emitters = "jeepDebrisTrailEmitter";

	shapeFile = "./M12_LRV_LAAG.dts";
	lifetime = 3.0;
	minSpinSpeed = -300.0;
	maxSpinSpeed = 300.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 1;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};



datablock ExplosionData(M12_LRV_LAAGExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 150;

   soundProfile = vehicleExplosionSound;
   
   emitter[0] = vehicleExplosionEmitter;
   emitter[1] = vehicleExplosionEmitter2;

   debris = LAAGDebris;
   debrisNum = 1;
   debrisNumVariance = 0;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 20;
   debrisVelocity = 18;
   debrisVelocityVariance = 3;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "10.0 10.0 10.0";
   camShakeDuration = 0.75;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 20;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 15;
   impulseForce = 1000;
   impulseVertical = 2000;

   //radius damage
   radiusDamage        = 30;
   damageRadius        = 8.0;

   //burn the players?
   playerBurnTime = 5000;

};



datablock DebrisData(M12_LRVDebris)
{
   emitters = "jeepDebrisTrailEmitter";

	shapeFile = "./M12_LRV.dts";
	lifetime = 3.0;
	minSpinSpeed = -300.0;
	maxSpinSpeed = 300.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 1;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ExplosionData(M12_LRVShellExplosion)
{
   explosionShape = "";
   soundProfile = rocketExplodeSound;

   lifeTimeMS = 150;


   particleEmitter = gravityRocketExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = gravityRocketExplosionRingEmitter;
   emitter[1] = gravityRocketExplosionChunkEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 20;
   lightStartColor = "1 1 0 1";
   lightEndColor = "1 0 0 0";

   damageRadius = 8;
   radiusDamage = 170;

   impulseRadius = 15;
   impulseForce = 5000;

   playerBurnTime = 5000;
};




datablock ProjectileData(BlankProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 0;
   directDamageType = $DamageType::M12_LRVShellDirect;
   radiusDamageType = $DamageType::M12_LRVShellRadius;
   impactImpulse	   = 0;
   verticalImpulse	   = 0;

  // sound = rocketLoopSound;

   muzzleVelocity      = 1;

   armingDelay         = 0;
   lifetime            = 1;
   fadeDelay           = 4000;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 1.0;

   hasLight    = false;
   lightRadius = 5.0;
   lightColor  = "1 0.5 0.0";

   explodeOnDeath = 0;

   uiName = "Blank Projectile"; //naming it this way so it's next to the rocket in the alphabetized list
};

