//########## M12 LRV Warthog

//### Effects

datablock AudioDescription(M12_LRVLooping3d)
{
   volume   = 20.0;
   isLooping= true;

   is3D     = true;
   ReferenceDistance= 5.5;
   MaxDistance= 100.0;
   type     = $SimAudioType;
};
datablock AudioProfile(M12_LRVSound)
{
   filename    = "./Engine.wav";
   description = M12_LRVLooping3d;
   preload = true;
};

datablock AudioProfile(M12_LRVFireSound)
{
  filename = "./fire.wav";
  description = AudioDefault3d;
  preload = true;
};

datablock ParticleData(M12_LRVTireParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = 0;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.5 0.5 0.5 0.3";
  colors[1] = "0.8 0.8 0.8 0";
  sizes[0] = 2;
  sizes[1] = 6;
  useInvAlpha = true;
};

datablock ParticleEmitterData(M12_LRVTireEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 25;
  ejectionVelocity = 2;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "M12_LRVTireParticle";
  useEmitterColors = true;
};

//### Vehicle

datablock WheeledVehicleData(M12_LRVVehicle)
{
  uiName = "M12 LRV Warthog";
  category = "Vehicles";
  displayName = "";
  shapeFile = "./M12_LRV.dts";
  emap = true;
  minMountDist = 3.5;
  numMountPoints = 3;
  mountThread[0] = "sit";
  mountThread[1] = "stand";
  mountThread[2] = "sit";
  numWheels = 4;
  engineTorque = 4000;
  engineBrake = 500;
  brakeTorque = 3000;
  maxWheelSpeed = 40;

  maxDamage = 200;
  destroyedLevel = 300;
  speedDamageScale = 1.04;
  collDamageThresholdVel = 20;
  collDamageMultiplier = 0.02;

  massCenter = "0 0 -1";

  maxSteeringAngle = 0.75;
  integration = 4;
  tireEmitter = M12_LRVTireEmitter;

  cameraRoll = false;
  cameraMaxDist = 13;
  cameraOffset = 6;
  cameraLag = 0;
  cameraDecay = 0.75;
  cameraTilt = 0.4;
  collisionTol = 0.1;
  contactTol = 0.1;
  useEyePoint = false;

  defaultTire = M12_LRVTire;
  defaultSpring = M12_LRVSpring;

  mass = 300;
  density = 5;
  drag = 1.6;
  bodyFriction = 0.6;
  bodyRestitution = 0.6;
  minImpactSpeed = 10;
  softImpactSpeed = 10;
  hardImpactSpeed = 20;
  groundImpactMinSpeed = 10;

  rollForce = 900;
  yawForce = 600;
  pitchForce = 1000;
  rotationalDrag = 0.2;

  steeringAutoReturn = true;
  steeringAutoReturnRate = 0.9;
  steeringAutoReturnMaxSpeed = 10;
  steeringUseStrafeSteering = true;
  steeringStrafeSteeringRate = 0.05;

  maxEnergy = 100;
  jetForce = 3000;
  minJetEnergy = 30;
  jetEnergyDrain = 2;

  splash = vehicleSplash;
  splashVelocity = 4;
  splashAngle = 67;
  splashFreqMod = 300;
  splashVelEpsilon = 0.6;
  bubbleEmitTime = 1.4;
  splashEmitter[0] = vehicleFoamDropletsEmitter;
  splashEmitter[1] = vehicleFoamEmitter;
  splashEmitter[2] = vehicleBubbleEmitter;
  mediumSplashSoundVelocity = 10;
  hardSplashSoundVelocity = 20;
  exitSplashSoundVelocity = 5;
  mediumSplashSound = "";
  hardSplahsSound = "";
  exitSplashSound = "";
  jetSound = "";
  engineSound = "";
  squealSound = "";
  softImpactSound = slowImpactSound;
  hardImpactSound = fastImpactSound;
  wheelImpactSound = "";

  justcollided = 0;

  rideable = true;
  lookUpLimit = 0.65;
  lookDownLimit = 0.45;

  paintable = true;

  damageEmitter[0] = VehicleBurnEmitter;
  damageEmitterOffset[0] = "0 0 0";
  damageLevelTolerance[0] = 0.99;

  damageEmitter[1] = VehicleBurnEmitter;
  damageEmitterOffset[1] = "0 0 0";
  damageLevelTolerance[1] = 1;

  numDmgEmitterAreas = 1;

  initialExplosionProjectile = JeepExplosionProjectile;
  initialExplosionOffset = 0;

  burnTime = 4000;

  finalExplosionProjectile = JeepFinalExplosionProjectile;
  finalExplosionOffset = 0.5;

  minRunOverSpeed = 4;
  runOverDamageScale = 8;
  runOverPushScale = 1.2;

  protectPassengersBurn = true;
  protectPassengersRadius = true;
  protectPassengersDirect = false;
};

function M12_LRVVehicle::onAdd(%this,%obj)
{

  %obj.PlayAudio(0,M12_LRVSound);

}